//sample multiplayer level script


#include <inc\sc_MPglobal.h>


// mplevel.inc 

void DisableCrates(void){				//this function will disable all crates
	dword i;
	char txt[256];
	void *nod,*chi;

	for (i=0;i<100;i++){

		sprintf(txt,"bedna%d",i);		//standard crate name is "bedna"+number
		
		nod = SC_NOD_GetNoMessage_Entity(txt);
		if (nod){					
			SC_NOD_SetDSTR(nod,"Bedna_dlouha",NULL);		//set destruction to NULL = object disappears

			chi = SC_NOD_GetNoMessage(nod,"Bedna_dlouha_viko");
			if (chi) SC_NOD_SetDSTR(nod,"Bedna_dlouha_viko",NULL);	//if exists subobject, disable it also
		}
	

	}// for (i)


}// void DisableBedny(void)


void DisableRW(void){			//this function will disable Real War Flags
	dword i;
	char txt[32];
	void *nod;

	for (i=0;i<20;i++){

		sprintf(txt,"W%c_flag",'A'+i);
		
		nod = SC_NOD_GetNoMessage_Entity(txt);
		if (nod){					
			SC_DUMMY_Set_DoNotRenHier2(nod,TRUE);
		}	

	}// for (i)

}// void DisableRW(void)


void DisableTT(void){			//this function will disable turn table flags
	dword i;
	char txt[32];
	void *nod;	

	for (i=0;i<20;i++){

		sprintf(txt,"TT_flag_%d",i);
		
		nod = SC_NOD_GetNoMessage_Entity(txt);
		if (nod){					
			SC_DUMMY_Set_DoNotRenHier2(nod,TRUE);
		}	

	}// for (i)

}// void DisableRW(void)


void SetAmmoBoxes(char *name, BOOL enable){		//this function will enable or disable ammo boxes
	dword i;
	char txt[256];
	void *nod,*chi;


	if (!SC_MP_GetAmmoBoxesEnabled()) enable = FALSE;

	for (i=0;i<10;i++){

		sprintf(txt,"%s%d",name,i);
		
		nod = SC_NOD_GetNoMessage_Entity(txt);
		if (nod){

			if (enable){
				SC_SetObjectScript(txt,"Ini\\Multiplayer\\scripts\\addammo_dobj.c");	//set the object script
			}// if (enable)
			else{
				SC_NOD_SetDSTR(nod,"Bedna_Kratka",NULL);
				chi = SC_NOD_GetNoMessage(nod,"Bedna_dlouha_viko");
				if (chi) SC_NOD_SetDSTR(nod,"Bedna_dlouha_viko",NULL);	//if exists subobject, disable it also
			}

		}// if (nod)
	
	}// for (i)

}// void SetAmmoBoxes(char *name, BOOL enable)



dword gphase = 0;


int ScriptMain(s_SC_L_info *info){
	s_SC_initside initside;
	s_SC_initgroup initgroup;
	BOOL hide_weapons,hide_CTF_flags,teamgame,hideRW,hideTT;
	void *nod;


   	info->next_exe_time  = 10.0f;

   
   switch (info->message){

   case SC_LEV_MES_INITSCENE:
	   
	   

		// hide C4
		nod = SC_NOD_Get(NULL,"c4");
		if (nod) SC_DUMMY_Set_DoNotRenHier2(nod,TRUE);			//if exists C4 explosive model, hide it

		SC_SetMapFpvModel("g\\weapons\\Vvh_map\\map_nvabaseMP.BES");		//set the FPV map model
		SC_ArtillerySupport(FALSE);

		hide_weapons = TRUE;
		hide_CTF_flags = TRUE;
		teamgame = TRUE;
		hideRW = TRUE;
		hideTT = TRUE;

		switch(SC_ggi(GVAR_MP_MISSIONTYPE)){				//set according to the mission type

		case GVAR_MP_MISSIONTYPE_RW:					//real war
				SC_sgf(400,15);
				SC_sgf(401,5);
				hideRW = FALSE;
				break;

		case GVAR_MP_MISSIONTYPE_ATG:		   			//assault team game	
				break;

		case GVAR_MP_MISSIONTYPE_CTF:					//capture the flag
				hide_CTF_flags = FALSE;
				SC_sgf(400,25);
				SC_sgf(401,5);
				break;

		case GVAR_MP_MISSIONTYPE_CTR:					//capture the radio
		case GVAR_MP_MISSIONTYPE_LMS:					//last man standing
		case GVAR_MP_MISSIONTYPE_DM:					//deathmatch
				teamgame = FALSE;
				hide_weapons = FALSE;
				break;

		case GVAR_MP_MISSIONTYPE_TDM:					//team death match
				hide_weapons = FALSE;
				break;

		case GVAR_MP_MISSIONTYPE_TT:					//turn table
				hideTT = FALSE;
				break;


		}// switch(SC_ggi(GVAR_MP_MISSIONTYPE))

		SC_MP_SetTeamGame(teamgame);					//is the game type team game, or every one for himself?

		if (hide_weapons){
			SC_MP_SRV_InitWeaponsRecovery(-1.0f);
			DisableCrates();
		}// if (hide_weapons)

		if (hide_CTF_flags){
			nod = SC_NOD_GetNoMessage_Entity("flag_us");
			if (nod) SC_DUMMY_Set_DoNotRenHier2(nod,TRUE);

			nod = SC_NOD_GetNoMessage_Entity("flag_vc");
			if (nod) SC_DUMMY_Set_DoNotRenHier2(nod,TRUE);

			SetAmmoBoxes("AmmoboxCTF",FALSE);
		}// if (hide_CTF_flags)
		else{
			SetAmmoBoxes("AmmoboxCTF",TRUE);
		}

		if (hideRW){
			DisableRW();
			SetAmmoBoxes("AmmoboxRW",FALSE);
		}// if (hideRW)
		else
			SetAmmoBoxes("AmmoboxRW",TRUE);


		if (hideTT) DisableTT();



		break;

   case SC_LEV_MES_TIME:

	switch (gphase){
	case 0:							//first time init
		CLEAR(initside);
		CLEAR(initgroup);
		
		//create sides and default groups
		
		initside.MaxHideOutsStatus = 64;		//init sides and groups
		initside.MaxGroups = 8;
		SC_InitSide(SC_P_SIDE_US,&initside);

		initside.MaxHideOutsStatus = 64;
		initside.MaxGroups = 8;
		SC_InitSide(SC_P_SIDE_VC,&initside);


		initgroup.SideId = SC_P_SIDE_US;		//US a-team
		initgroup.GroupId = 0;
		initgroup.MaxPlayers = 64;			// DO NOT CHANGE!
		SC_InitSideGroup(&initgroup);


		initgroup.SideId = SC_P_SIDE_VC; 		//generic Vietcong
		initgroup.GroupId = 0;
		initgroup.MaxPlayers = 64;			// DO NOT CHANGE
		SC_InitSideGroup(&initgroup);

		
		gphase=1;
		break;
	}// gphase switch
   	break;
}

	return 1;

}// int ScriptMain(void)






